#include "Timer.h"
#include "kIndustryCalendar.h"



//job1
void job1() {
	unsigned long time = millis();
	Serial.print("Job1: ");
	Serial.println(time);
}

//job2
void job2() {
	unsigned long time = millis();
	Serial.print("Job2: ");
	Serial.println(time);
}

void job3() {
	Serial.println("Ban da nhan phim tren Serial");
}

bool waitForSerial() {
  bool res = Serial.available();
  while (Serial.available())
    Serial.read();
  return res;
}

void setup()
{
	
	//Khởi tạo serial ở mức baudrate 115200
	Serial.begin(115200);

	//Khởi gạo class timer (design pattern singleton) - bắt buộc phải có trong hàm setup (trước khi khởi tạo các job)
	Timer::getInstance()->initialize();

	//Khởi tạo lịch, các công việc phải được sắp xếp theo chiều thời gian tăng dần để tránh lỗi
	kIndustryCalendar::getInstance()->initialize();
	//Chạy lệnh job1 ở thời điểm 0 trong chu kỳ
	kIndustryCalendar::getInstance()->addJob(job1, (unsigned long)0);
	//Chạy lệnh job2 ở thời điểm 1000ms trong chu kỳ
	kIndustryCalendar::getInstance()->addJob(job2, (unsigned long)1000);

  kIndustryCalendar::getInstance()->addJob(job3, waitForSerial);

	//Bắt đầu tính giờ thời gian của quy trình đầu tiên
	kIndustryCalendar::getInstance()->startFirstJob();
}

//trong hàm loop chỉ nên có những hàm này, bạn muốn viết một chức năng khác? Xin hãy tạo một job và đưa vào thời khóa biểu scheduler như hàm dưới

void loop()
{
	//đầu hàm loop phải có để cập nhập thời điểm diễn ra việc kiểm tra lại các tiến trình
	Timer::getInstance()->update();
	
	kIndustryCalendar::getInstance()->update();

	//cuối hàm loop phải có để cập nhập lại THỜI ĐIỂM (thời điểm chứ ko phải thời gian nha, tuy tiếng Anh chúng đều là time) để cho lần xử lý sau
	Timer::getInstance()->resetTick();
	
}
